<!DOCTYPE html>
<html lang="en">

<head>
	<title>Menu</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>

	<div class="container">
		<h2 style="text-align: center;">Quản trị Menu</h2>
		<div class="jumbotron container">
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="voucher-code">Size</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-size" name="size" placeholder="Kích cỡ"
						class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="discount">Đường kính</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-duong-kinh" name="duongKinh" placeholder="Đường kính"
						class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="note">Sườn</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-suon" name="suon" placeholder="Sườn" class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="note">Salad</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-salad" name="salad" placeholder="salad" class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="note">Số lượng nước</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-so-luong-nuoc" name="soLuongNuoc" placeholder="Số lượng nước" class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="note">Đơn giá</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-price" name="price" placeholder="Đơn giá" class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="updateDate">Ngày tạo</label>
				</div>
				<div class="col-sm-9">
					<input type="date" id="input-ngay-tao" name="newDate" placeholder="Ngày tạo" class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="updateDate">Ngày sửa</label>
				</div>
				<div class="col-sm-9">
					<input type="date" id="input-updateDate" name="updateDate" placeholder="Update Date"
						class="form-control">
				</div>
			</div>
			<div class="row pull-right">
				<div>
					<button id="detail" class="btn btn-info">Detail</button>
				</div>
				<div class="ml-2">
					<button id="delete_data" class="btn btn-danger">Delete Data</button>
				</div>
				<div class="ml-2">
					<button id="delete_data_all" class="btn btn-danger">Delete All Data</button>
				</div>
			</div>
		</div>
		<table class="table table-bordered table-striped table-hover" id="user-table">
			<thead>
				<tr>
					<th>ID</th>
					<th>Size</th>
					<th>Đường kính</th>
					<th>Sườn</th>
					<th>Salad</th>
					<th>Số lượng nước</th>
					<th>Đơn giá</th>
					<th>Ngày tạo</th>
					<th>Ngày cập nhật</th>
				</tr>
		</table>
	</div>
	<script>



		$(document).ready(function () {
			var gID = "";
			var gFORM_MODE_INSERT = "Insert";
			var gFORM_MODE_UPDATE = "Update";
			var gFormMode = gFORM_MODE_INSERT;

			var table = $("#user-table").DataTable({
				"columns": [
					{ "data": "id" },
					{ "data": "size" },
					{ "data": "duongKinh" },
					{ "data": "suon" },
					{ "data": "salaf"},
					{ "data": "soLuongNuocNgot"},
					{ "data": "donGia"},
					{ "data": "ngayTao" },
					{ "data": "ngayCapNhat" },
				]
			})

			$.ajax({
				url: "http://localhost:8080/menus",
				type: "GET",
				dataType: "json",
				success: function (res) {
					console.log(res);
					table.clear();
					table.rows.add(res);
					table.draw();
				},
				error: function (err) {
					console.log(err.response);
				}
			});



			$(document).on('click', "tr", function () {
				onBtnDetailClick(this);
			})

			$(document).on('click', "#delete_data", function () {
				onBtnDeleteClick(this);
			})

			$(document).on('click', "#delete_data_all", function () {
				onBtnAllDeleteClick(this);
			})

			$(document).on('click', "#detail", function () {
				onBtnSaveDataClick(this)
			})

			function onBtnDetailClick(paramElement) {

				gFormMode = gFORM_MODE_UPDATE;
				var vRowSelected = $(paramElement).closest("tr");
				var vTable = $("#user-table").DataTable();
				var vDataRow = vTable.row(vRowSelected).data();
				gID = vDataRow.id;
				$.ajax({
					url: "http://localhost:8080/menu/" + gID,
					type: 'GET',
					success: function (res) {
						console.log(res);
						$("#input-size").val(res.size);
						$("#input-duong-kinh").val(res.duongKinh);
						$("#input-suon").val(res.suon);
						$("#input-salad").val(res.salad);
						$("#input-so-luong-nuoc").val(res.soLuongNuocNgot);
						$("#input-price").val(res.donGia);
						let vCreateDate = res.ngayTao.slice(6, 10) + "-" + res.ngayTao.slice(3.5) + res.ngayTao.slice(0, 2);
						$("#input-ngay-tao").val(vCreateDate);
						if (res.ngayCapNhat != null) {
							let vUpdateDate = res.ngayCapNhat.slice(6, 10) + "-" + res.ngayCapNhat.slice(3.5) + res.ngayCapNhat.slice(0, 2);
							$("#input-updateDate").val(vUpdateDate);
						} else {
							$("#input-updateDate").val("");
						}

					},
					error: function (err) {
						console.log(err.status)
					}
				})
			}

			function onBtnSaveDataClick() {
				if (gFormMode === gFORM_MODE_UPDATE) {
					let vObjectRequest = {
						id: gID,
						size: $("#input-size").val(),
						duongKinh: $("#input-duong-kinh").val(),
						suon: $("#input-suon").val(),
						salad: $("#input-salad").val(),
						soLuongNuocNgot: $("#input-so-luong-nuoc").val(),
						donGia: $("#input-price").val()
					};

					$.ajax({
						url: "http://localhost:8080/update-menus/" + gID,
						contentType: "application/json; charset=UTF-8",
						type: 'PUT',
						dataType: "json",
						data: JSON.stringify(vObjectRequest),
						success: function (res) {
							window.location.reload();
						},
						error: function (err) {
							console.log(err.status)
						}
					})
				}else {
					let vObjectRequest = {
						id: gID,
						size: $("#input-size").val(),
						duongKinh: $("#input-duong-kinh").val(),
						suon: $("#input-suon").val(),
						salad: $("#input-salad").val(),
						soLuongNuocNgot: $("#input-so-luong-nuoc").val(),
						donGia: $("#input-price").val()
					}
					$.ajax({
						url: "http://localhost:8080/created-menus/",
						contentType: "application/json; Charset=UFT-8",
						type: 'POST',
						dataType: "json",
						data: JSON.stringify(vObjectRequest),
						success: function (res) {
							window.location.reload();
						},
						error: function (err) {
							console.log(err.status)
						}
					})
				}
			}

			function onBtnDeleteClick() {
				if(confirm("bạn có muốn xóa?") == true) {


					$.ajax({
						url: "http://localhost:8080/delete-menus/" + gID,
						type: "DELETE",
						dataType: "json",
						success: function(res) {
							window.location.reload();
						},
						error: function(err) {
							console.log(err.response);
						}
					})
				}
			}

			function onBtnAllDeleteClick() {
				if(confirm("bạn có muốn xóa hết toàn bộ danh sách drink?") == true) {
					$.ajax({
						url: "http://localhost:8080/delete-menus",
						type: "DELETE",
						dataType: "json",
						success: function(res) {
							window.location.reload();
						},
						error: function(err) {
							console.log(err.response);
						}
					})
				}
			}


		});



	</script>
</body>

</html>